#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#if defined(WIN32)
//#  pragma comment(linker, "/subsystem:\"windows\" /entry:\"mainCRTStartup\"")
#  include "glut.h"
#  include "glext.h"
PFNGLACTIVETEXTUREPROC glActiveTexture;
#elif defined(__APPLE__) || defined(MACOSX)
#  include <GLUT/glut.h>
#else
#  include <GL/glut.h>
#endif

/*
** 
*/
static const GLfloat lightpos[] = { 0.0, 0.0, 1.0, 0.0 }; /* ʒu@@@ */
static const GLfloat lightcol[] = { 1.0, 1.0, 1.0, 1.0 }; /* ڌx */
static const GLfloat lightamb[] = { 0.1, 0.1, 0.1, 1.0 }; /* x */

/*
** eNX`
*/
#define TEXWIDTH  256                      /* eNX`̕@@@ */
#define TEXHEIGHT 256                      /* eNX`̍@@ */
static const char texture1[] = "dot.raw";  /* eNX`t@C */

/*
** 
*/
static void init(void)
{
  /* eNX`̓ǂݍ݂Ɏgz */
  GLubyte texture[TEXHEIGHT * TEXWIDTH * 4];
  FILE *fp;
  
  /* eNX`摜̓[hPʂɋlߍ܂Ă */
  glPixelStorei(GL_UNPACK_ALIGNMENT, 4);
  
  /* eNX`摜̓ǂݍ */
  if ((fp = fopen(texture1, "rb")) != NULL) {
    fread(texture, sizeof texture, 1, fp);
    fclose(fp);
  }
  
  /* eNX`̊蓖 */
  glTexImage2D(GL_TEXTURE_2D, 0, GL_RGBA, TEXWIDTH, TEXHEIGHT, 0,
    GL_RGBA, GL_UNSIGNED_BYTE, texture);
  
  /* eNX`gEk@̎w */
  glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
  glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
  
  /* eNX`̌JԂ@̎w */
  glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP);
  glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP);
  
  /* eNX` */
  glTexEnvi(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE);
  
#if defined(WIN32)
  glActiveTexture =
    (PFNGLACTIVETEXTUREPROC)wglGetProcAddress("glActiveTexture");
#endif
  
  /* eNX`jbgPɐ؂ւ */
  glActiveTexture(GL_TEXTURE1);
  
  for (int i = 0; i < 6; ++i) {
    /* eNX`t@C */
    static const char *textures[] = {
      "room2ny.raw", /*  */
      "room2nz.raw", /*  */
      "room2px.raw", /* E */
      "room2pz.raw", /* O */
      "room2nx.raw", /*  */
      "room2py.raw", /*  */
    };
    /* eNX`̃^[Qbg */
    static const int target[] = {
      GL_TEXTURE_CUBE_MAP_NEGATIVE_Y,
      GL_TEXTURE_CUBE_MAP_NEGATIVE_Z,
      GL_TEXTURE_CUBE_MAP_POSITIVE_X,
      GL_TEXTURE_CUBE_MAP_POSITIVE_Z,
      GL_TEXTURE_CUBE_MAP_NEGATIVE_X,
      GL_TEXTURE_CUBE_MAP_POSITIVE_Y,
    };
    
    if ((fp = fopen(textures[i], "rb")) != NULL) {
      /* eNX`摜̓ǂݍ */
      fread(texture, 128 * 128 * 4, 1, fp);
      fclose(fp);
      
      /* L[u}bsÕeNX`̊蓖 */
      glTexImage2D(target[i], 0, GL_RGBA, 128, 128, 0, 
        GL_RGBA, GL_UNSIGNED_BYTE, texture);
    }
  }
  
  /* eNX`gEk@̎w */
  glTexParameteri(GL_TEXTURE_CUBE_MAP, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
  glTexParameteri(GL_TEXTURE_CUBE_MAP, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
  
  /* eNX`̌JԂ@̎w */
  glTexParameteri(GL_TEXTURE_CUBE_MAP, GL_TEXTURE_WRAP_S, GL_CLAMP);
  glTexParameteri(GL_TEXTURE_CUBE_MAP, GL_TEXTURE_WRAP_T, GL_CLAMP);
  
  /* eNX`jbgP̃eNX` */
  glTexEnvi(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_COMBINE);
  glTexEnvi(GL_TEXTURE_ENV, GL_COMBINE_RGB, GL_INTERPOLATE);
#if 0
  static const GLfloat blend[] = { 1.0, 1.0, 1.0, 0.5 };
  glTexEnvfv(GL_TEXTURE_ENV, GL_TEXTURE_ENV_COLOR, blend);
#else
  glTexEnvi(GL_TEXTURE_ENV, GL_SOURCE2_RGB, GL_PREVIOUS);
  glTexEnvi(GL_TEXTURE_ENV, GL_OPERAND2_RGB, GL_SRC_ALPHA);
#endif
  
  /* L[u}bsOp̃eNX`W𐶐 */
  glTexGeni(GL_S, GL_TEXTURE_GEN_MODE, GL_REFLECTION_MAP);
  glTexGeni(GL_T, GL_TEXTURE_GEN_MODE, GL_REFLECTION_MAP);
  glTexGeni(GL_R, GL_TEXTURE_GEN_MODE, GL_REFLECTION_MAP);
  
  /* eNX`jbgOɖ߂ */
  glActiveTexture(GL_TEXTURE0);
  
  /* ݒ */
  glClearColor(0.3, 0.3, 1.0, 0.0);
  glEnable(GL_DEPTH_TEST);
  glDisable(GL_CULL_FACE);
  
  /* ̏ݒ */
  glEnable(GL_LIGHTING);
  glEnable(GL_LIGHT0);
  glLightfv(GL_LIGHT0, GL_DIFFUSE, lightcol);
  glLightfv(GL_LIGHT0, GL_SPECULAR, lightcol);
  glLightfv(GL_LIGHT0, GL_AMBIENT, lightamb);
}

/* gbN{[p֐̐錾 */
#include "trackball.h"

/* `֐̐錾 */
#include "box.h"

/*
** V[̕`
*/
static void scene(void)
{
  static const GLfloat color[] = { 1.0, 1.0, 1.0, 1.0 };  /* ގ (F) */
  
  /* ގ̐ݒ */
  glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, color);
  
  /* eNX`}bsOJn */
  glEnable(GL_TEXTURE_2D);
  
  /* eNX`jbgPɐ؂ւ */
  glActiveTexture(GL_TEXTURE1);
  
  /* L[u}bsOJn */
  glEnable(GL_TEXTURE_CUBE_MAP);
  glEnable(GL_TEXTURE_GEN_S);
  glEnable(GL_TEXTURE_GEN_T);
  glEnable(GL_TEXTURE_GEN_R);
  
  /* gbN{[ɂ] */
  glMultMatrixd(trackballRotation());

  /* ` */
  box(1.0, 1.0, 1.0);
  
  /* L[u}bsOI */
  glDisable(GL_TEXTURE_GEN_S);
  glDisable(GL_TEXTURE_GEN_T);
  glDisable(GL_TEXTURE_GEN_R);
  glDisable(GL_TEXTURE_CUBE_MAP);
  
  /* eNX`jbgOɖ߂ */
  glActiveTexture(GL_TEXTURE0);
  
  /* eNX`}bsOI */
  glDisable(GL_TEXTURE_2D);
}


/****************************
** GLUT ̃R[obN֐ **
****************************/

static void display(void)
{
  /* ʃNA */
  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
  
  /* fr[ϊs̐ݒ */
  glMatrixMode(GL_MODELVIEW);
  glLoadIdentity();
  
  /* ̈ʒuݒ */
  glLightfv(GL_LIGHT0, GL_POSITION, lightpos);
  
  /* _̈ړî̕Ɉړj*/
  glTranslated(0.0, 0.0, -5.0);
  
  /* V[̕` */
  scene();
  
  /* _uobt@O */
  glutSwapBuffers();
}

static void resize(int w, int h)
{
  /* gbN{[͈ */
  trackballRegion(w, h);
  
  /* EBhEŜr[|[gɂ */
  glViewport(0, 0, w, h);
  
  /* ϊs̎w */
  glMatrixMode(GL_PROJECTION);
  
  /* ϊs̏ */
  glLoadIdentity();
  gluPerspective(40.0, (double)w / (double)h, 1.0, 100.0);
}

static void idle(void)
{
  /* ʂ̕`ւ */
  glutPostRedisplay();
}

static void mouse(int button, int state, int x, int y)
{
  switch (button) {
  case GLUT_LEFT_BUTTON:
    switch (state) {
    case GLUT_DOWN:
      /* gbN{[Jn */
      trackballStart(x, y);
      glutIdleFunc(idle);
      break;
    case GLUT_UP:
      /* gbN{[~ */
      trackballStop(x, y);
      glutIdleFunc(0);
      break;
    default:
      break;
    }
    break;
    default:
      break;
  }
}

static void motion(int x, int y)
{
  /* gbN{[ړ */
  trackballMotion(x, y);
}

static void keyboard(unsigned char key, int x, int y)
{
  switch (key) {
  case 'q':
  case 'Q':
  case '\033':
    /* ESC  q  Q ^CvI */
    exit(0);
  default:
    break;
  }
}

/*
** CvO
*/
int main(int argc, char *argv[])
{
  glutInit(&argc, argv);
  glutInitDisplayMode(GLUT_RGBA | GLUT_DEPTH | GLUT_DOUBLE);
  glutCreateWindow(argv[0]);
  glutDisplayFunc(display);
  glutReshapeFunc(resize);
  glutMouseFunc(mouse);
  glutMotionFunc(motion);
  glutKeyboardFunc(keyboard);
  init();
  glutMainLoop();
  return 0;
}
